// strict mode（厳密な構文チェックを有効化）
"use strict";
(function(){
	// KuruBooks名前空間
	var KuruBooks = {
		kuruInit: function(){ // 初期化
			if(document.getElementById("KuruBooks-toolbar-button") != null){
				// 履歴サービス初期化
				KuruBooks.historyService = Components.classes["@mozilla.org/browser/nav-history-service;1"].getService(Components.interfaces.nsINavHistoryService);
				// 空のクエリオブジェクトを取得
				KuruBooks.options = KuruBooks.historyService.getNewQueryOptions();
				// オプションオブジェクトを取得
				KuruBooks.query = KuruBooks.historyService.getNewQuery();
				// ブックマークサービス初期化
				KuruBooks.bookmarksService = Components.classes["@mozilla.org/browser/nav-bookmarks-service;1"].getService(Components.interfaces.nsINavBookmarksService);
				// 二重起動制御フラグ
				KuruBooks.kuru_flag = false;
				// イベントリスナー追加
				document.getElementById("KuruBooks-toolbar-button").addEventListener("command", KuruBooks.kuruButtonCommand, false);
				document.getElementById("KuruBooks-popup").addEventListener("popupshowing", KuruBooks.kuruMenuCreate, false);
			}
		},
		kuruButtonCommand: function(){ // ボタンコマンドイベント関数
			KuruBooks.kurukuru(KuruBooks.kuruMenuGet(0));
		},
		kuruMenuClick: function(event){ // メニュークリックイベント関数
			event.stopPropagation(); // バブリング停止
			KuruBooks.kurukuru(this.value);
		},
		kuruMenuGet: function(kuru_itemId){ // ブックマークツールバーアイテム取得
			// ブックマークメニューフォルダの取得
			var bookmarksMenuFolder = KuruBooks.bookmarksService.bookmarksMenuFolder; // ブックマークメニューフォルダID取得
			KuruBooks.query.setFolders([bookmarksMenuFolder], 1); // クエリの設定（フォルダID設定）
			var result = KuruBooks.historyService.executeQuery(KuruBooks.query, KuruBooks.options); // クエリの実行
			var bookmarksMenuFolder_rootNode = result.root;
			bookmarksMenuFolder_rootNode.containerOpen = true; // コンテナオープン
			// 対象フォルダカウント
			var targetFolder_Count = 0;
			for(var i = 0; i < bookmarksMenuFolder_rootNode.childCount; i++){
				var child_node = bookmarksMenuFolder_rootNode.getChild(i);
				if(child_node.type == 6){ // フォルダのみ選択
					targetFolder_Count++;
				}
			}
			// 指定アイテム取得
			var kuru_count = 0;
			if(targetFolder_Count > 0){
				for(var i = 0; i < bookmarksMenuFolder_rootNode.childCount; i++){
					var child_node = bookmarksMenuFolder_rootNode.getChild(i);
					if(child_node.type == 6){ // フォルダのみ選択
						if(kuru_itemId == kuru_count){
							return child_node.itemId;
							break;
						}
						kuru_count++;
					}
				}
			}
			// コンテナクローズ
			bookmarksMenuFolder_rootNode.containerOpen = false;
		},
		kuruMenuCreate: function(){ // メニューアイテム生成
			// KuruBooks-popupを取得
			var kuru_popup = document.getElementById("KuruBooks-popup");
			// メニューアイテム削除
			while(kuru_popup.firstChild){
				var child_node = kuru_popup.firstChild;
				kuru_popup.removeChild(child_node);
			}
			// ブックマークメニューフォルダの取得
			var bookmarksMenuFolder = KuruBooks.bookmarksService.bookmarksMenuFolder; // ブックマークメニューフォルダID取得
			KuruBooks.query.setFolders([bookmarksMenuFolder], 1); // クエリの設定（フォルダID設定）
			var result = KuruBooks.historyService.executeQuery(KuruBooks.query, KuruBooks.options); // クエリの実行
			var bookmarksMenuFolder_rootNode = result.root;
			bookmarksMenuFolder_rootNode.containerOpen = true; // コンテナオープン
			// 対象フォルダカウント
			var targetFolder_Count = 0;
			for(var i = 0; i < bookmarksMenuFolder_rootNode.childCount; i++){
				var child_node = bookmarksMenuFolder_rootNode.getChild(i);
				if(child_node.type == 6){ // フォルダのみ選択
					targetFolder_Count++;
				}
			}
			// メニュー作成
			if(targetFolder_Count > 0){
				for(var i = 0; i < bookmarksMenuFolder_rootNode.childCount; i++){
					var child_node = bookmarksMenuFolder_rootNode.getChild(i);
					if(child_node.type == 6){ // フォルダのみ選択
						var tempNode = document.createElement("menuitem");
						tempNode.setAttribute("className", "kuru-menuitem");
						tempNode.setAttribute("label", child_node.title);
						tempNode.setAttribute("value", child_node.itemId);
						tempNode.addEventListener("command", KuruBooks.kuruMenuClick, false);
						kuru_popup.appendChild(tempNode);
					}
				}
			}
			else {
				var localBundle = document.getElementById("KuruBooks_strings");
				var menuitem_label = localBundle.getString("menuitem_notfound");
				var tempNode = document.createElement("menuitem");
				tempNode.setAttribute("className", "kuru-menuitem");
				tempNode.setAttribute("label", menuitem_label);
				tempNode.setAttribute("value", undefined);
				tempNode.setAttribute("disabled", true);
				kuru_popup.appendChild(tempNode);
			}
			// コンテナクローズ
			bookmarksMenuFolder_rootNode.containerOpen = false;
		},
		kurukuru: function(node_id){ // ブックマークツールバー変更
			if(KuruBooks.kuru_flag == false && isNaN(node_id) == false){
				// 二重起動制御フラグオン
				KuruBooks.kuru_flag = true;
				// ブックマークツールバーの取得
				var toolbarFolder = KuruBooks.bookmarksService.toolbarFolder; // ブックマークツールバーID取得
				KuruBooks.query.setFolders([toolbarFolder], 1); // クエリの設定（フォルダID設定）
				var result = KuruBooks.historyService.executeQuery(KuruBooks.query, KuruBooks.options); // クエリの実行
				var toolbarFolder_rootNode = result.root;
				toolbarFolder_rootNode.containerOpen = true; // コンテナオープン
				// 指定されたIDを持つフォルダの取得
				KuruBooks.query.setFolders([node_id], 1); // クエリの設定（フォルダID設定）
				result = KuruBooks.historyService.executeQuery(KuruBooks.query, KuruBooks.options); // クエリの実行
				var bookmarksFolder_rootNode = result.root;
				bookmarksFolder_rootNode.containerOpen = true; // コンテナオープン
				// ブックマークメニューフォルダの取得
				var bookmarksMenuFolder = KuruBooks.bookmarksService.bookmarksMenuFolder; // ブックマークメニューフォルダID取得
				KuruBooks.query.setFolders([bookmarksMenuFolder], 1); // クエリの設定（フォルダID設定）
				result = KuruBooks.historyService.executeQuery(KuruBooks.query, KuruBooks.options); // クエリの実行
				var bookmarksMenuFolder_rootNode = result.root;
				bookmarksMenuFolder_rootNode.containerOpen = true; // コンテナオープン
				// 退避用フォルダ作成
				var KuruBooksBackupID = KuruBooks.bookmarksService.createFolder(bookmarksMenuFolder, KuruBooks.bookmarksService.getItemTitle([toolbarFolder]), -1);
				// ブックマークツールバーのブックマークを退避用フォルダに移動
				var childNode_Count = toolbarFolder_rootNode.childCount;
				for(var i = 0; i < childNode_Count; i++){
					var child_node = toolbarFolder_rootNode.getChild(0);
					KuruBooks.bookmarksService.moveItem([child_node.itemId], [KuruBooksBackupID], -1);
				}
				// 指定フォルダのブックマークをブックマークツールバーに移動
				var childNode_Count = bookmarksFolder_rootNode.childCount;
				for(var i = 0; i < childNode_Count; i++){
					var child_node = bookmarksFolder_rootNode.getChild(0);
					KuruBooks.bookmarksService.moveItem([child_node.itemId], [toolbarFolder], -1);
				}
				// タイトル変更
				KuruBooks.bookmarksService.setItemTitle([toolbarFolder], KuruBooks.bookmarksService.getItemTitle([node_id]));
				// 指定フォルダ削除
				KuruBooks.bookmarksService.removeItem([node_id]);
				// コンテナクローズ
				bookmarksMenuFolder_rootNode.containerOpen = false;
				bookmarksFolder_rootNode.containerOpen = false;
				toolbarFolder_rootNode.containerOpen = false;
				// 二重起動制御フラグオフ
				KuruBooks.kuru_flag = false;
			}
		}
	};
	window.addEventListener("load", KuruBooks.kuruInit, false);
	window.addEventListener("aftercustomization", KuruBooks.kuruInit, false);
})();
